#include <assert.h>

int sorted_find(int a[], int size, int x) {
    int left = 0;
    int right = size - 1;
    
    while (left <= right) {
        int mid = left + ((right - left) / 2);
        if (x == a[mid])
            return mid;
        else if (x < a[mid])
            right = mid - 1;
        else // (x > a[mid])
            left = mid + 1;
    }
    return -left;
}

int sorted_a[] = {-10, -10, -7, -4, 1, 2, 2, 4, 5, 7, 10};

void test_sorted_find() {
    int size = sizeof(sorted_a) / sizeof(sorted_a[0]);
    for (int i = 0; i < size; i++) {
        int x = sorted_a[i];
        int index = sorted_find(sorted_a, size, x);
        printf("sorted_find(%d) = %d\n", x, index);
        // assert(x == sorted_a[index]);
    }

    for (int i = 0; i < size; i++) {
        int x = sorted_a[i] + 1;
        int index = sorted_find(sorted_a, size, x);
        printf("sorted_find(%d) = %d\n", x, index);
    }
}

int main(int argc, char *argv[])
{
    test_sorted_find();
}
